/*
 *    Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * Status.java
 *
 * File generated from the ATNAQuestionnaire::Status uml Enumeration
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.atna.questionnaire.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.hql.FilterLabel;

/**
 * Description of the enumeration Status.
 *
 */

@XmlType(name = "Status")
@XmlEnum
@XmlRootElement(name = "Status")
public enum Status {
	@XmlEnumValue("IN PROGRESS")
	INPROGRESS("In Progress", "vendor"),
	@XmlEnumValue("READY FOR REVIEW")
	READYTOREVIEW("Ready for review", null),
	@XmlEnumValue("REVIEWED AND VALID")
	REVIEWEDANDVALID("Reviewed and valid", "monitor"),
	@XmlEnumValue("ABORTED")
	ABORTED("Aborted", "vendor"),
	@XmlEnumValue("REVIEWED AND NOT VALID")
	REVIEWEDANDNOTVALID("Reviewed and not valid", "monitor");

	private final String value;
	private final String role;

	Status(String v, String r) {
		value = v;
		role = r;
	}

	public String value() {
		return value;
	}

	@FilterLabel
	public String getValue() {
		return value;
	}
	
	public String getRole(){
		return role;
	}

	public static Status fromValue(String v) {
		for (Status c : Status.values()) {
			if (c.value.equals(v)) {
				return c;
			}
		}
		throw new IllegalArgumentException(v);
	}

	public static List<Status> getStatusesForMonitor(){
		return getStatusesForRole("monitor");
	}
	
	public static List<Status> getStatusesForVendor(){
		return getStatusesForRole("vendor");
	}
	
	private static List<Status> getStatusesForRole(String role){
		List<Status> statuses = new ArrayList<Status>();
		for (Status status: values()){
			if (status.role == null || status.role.equals(role)){
				statuses.add(status);
			}
		}
		return statuses;
	}
}